Digest::Base - Crystal 0.35.1

# abstract class Digest::Base

- Digest::Base
- Reference
- Object

##
Direct Known Subclasses

- Digest::MD5
- Digest::SHA1
- OpenSSL::Digest

##
Defined in:

##
Instance Method Summary

- #digest : Bytes

  Dups and finishes the digest.

  DEPRECATED Use `#final` instead.

- #digest_size : Int32

  Returns the digest output size in bytes.

- #final(dst : Bytes) : Bytes
- #final : Bytes

  Returns the final digest output.

- #final_impl(dst : Bytes) : Nil

  Stores the output digest of #digest_size bytes in dst.

- #hexdigest : String

  Returns a hexadecimal-encoded digest.

  DEPRECATED Use `final.hexstring` instead.

- #reset : self
- #reset_impl : Nil

  Resets the object to it's initial state.

- #update(data : Bytes) : self
- #update(data) : self
- #update_impl(data : Bytes) : Nil

  Hashes data incrementally.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Instance Method Detail

def digest : Bytes #

Dups and finishes the digest.

DEPRECATED Use `#final` instead.

abstract def digest_size : Int32 #

Returns the digest output size in bytes.

def final(dst : Bytes) : Bytes #
def final : Bytes #

Returns the final digest output.

This method can only be called once and raises `FinalizedError` on subsequent calls.

NOTE `.dup.final` call may be used to get an intermediate hash value.

abstract def final_impl(dst : Bytes) : Nil #

Stores the output digest of #digest_size bytes in dst.

def hexdigest : String #

Returns a hexadecimal-encoded digest.

DEPRECATED Use `final.hexstring` instead.

def reset : self #
abstract def reset_impl : Nil #

Resets the object to it's initial state.

def update(data : Bytes) : self #
def update(data) : self #
abstract def update_impl(data : Bytes) : Nil #

Hashes data incrementally.